/*
 * IPC Basisklasse
 *
 * Definiert Funktionalitt, die alle IPC-Klassen anbieten.
 *
 * $Id: ipcbase.h,v 1.1.1.1 1997/10/28 10:49:44 frank Exp $
 */

#ifndef __IPCBASE_H__
#define __IPCBASE_H__

#include "fpconfig.h"

#include <stdio.h>
#include <string.h>


class cIPC {
public:
  cIPC (void);

  int           error     (void) const;
  const char *  strerror  (void);
  int           operator! (void);

protected:
  void  seterror (int = 0);
  void  seterror (const char *);

private:
  int myerrno;
  char sdummy[4];
  const char *othererr;
};

/*
 * Wird alles inline deklariert
 */

inline
cIPC::cIPC (void)
{
  myerrno = 0;
}

inline int
cIPC::error (void) const
{
  return myerrno;
}

inline const char *
cIPC::strerror (void)
{
  if (myerrno == -1) {
    return othererr;
  } else if (myerrno == 0) {
    return "ok";
  }
#ifndef HAVE_STRERROR
  sprintf (sdummy, "%3d", myerrno);
  return sdummy;
#else
  return ::strerror (myerrno);
#endif
}

inline int
cIPC::operator! (void)
{
  return myerrno;
}

inline void
cIPC::seterror (int err)
{
  myerrno = err;
}

inline void
cIPC::seterror (const char * str)
{
  myerrno  = -1;
  othererr = str;
}

#endif
