
#ifndef ITC_H
#define ITC_H

#include <pthread.h>

enum Mutex_Types {

	FASTMUTEX,
	RECMUTEX,
	DEBUGMUTEX
};

class c_condition;
	
class c_mutex {

	private:
	
		pthread_mutex_t m_handle;
		pthread_mutexattr_t m_attr;
		friend c_condition;

	public:

		c_mutex();
		c_mutex(Mutex_Types);
		~c_mutex();
		
		int lock();
		int unlock();

};

class c_condition {

	protected:
	
		pthread_cond_t c_handle;
		pthread_condattr_t c_attr;		

	public:
	
		c_condition();
		c_condition(pthread_condattr_t*);	
		~c_condition();
		
		int signal();
		int broadcast();
		int wait(c_mutex*);



};


class c_section {

	protected:
	
		pthread_cond_t c_handle;
		pthread_condattr_t c_attr;

		pthread_mutex_t m_handle;
		pthread_mutexattr_t m_attr;

	public:
	
		c_section();
		~c_section();
		
		int enter();
		int wait();
		int signal();
		int broadcast();
		int leave();

};

#endif ITC_H

