// -----------------------------------------------------------------------
// - Testprogramm zum Austesten der Multicast-Klasse    c) 1995 ABVS     -
// -----------------------------------------------------------------------
// HINWEIS: Bei der Adressausgabe in Punkt h ist die Portnummer irrelevant,
// da es sich ja hierbei um die Schreibsocket aus der Klasse c_socket_mc handelt,
// die an keinen Port gebunden wurde, an der also auch niemand zum Lesen wartet.

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <sys/ioctl.h>
#include <address_class.h>
#include <socket_class.h>
#include <socket_mc_class.h>
#include <stdlib.h>
#include <iostream.h>
#include <string.h>
#include <errno.h>


#define SD_PORT 9877

void main()
{
    char group[20] = "224.2.127.255";	
    char wahl;
    char buf[20];
    char hostbuf[32];
    c_address addr(group, SD_PORT);
    c_address addback;

    c_socket_mc msocket(addr);

    for(;;) {

        cout << "set group...........a\n";
        cout << "join group..........b\n";
        cout << "leave group.........c\n";
        cout << "set ttl.............d\n";
        cout << "read................e\n";
        cout << "write...............f\n";
        cout << "poll................g\n";
        cout << "last sender.........h\n";
        cout << "get group...........i\n";
        cout << "loopback ein........j\n";
        cout << "loopback aus........k\n";
	cout << "join interface......l\n";
        cout << "Bitte waehlen...";
        cin >> wahl; cout << '\n';

        switch (wahl)
        {
            case 'a':
            {
                char adresse[20];
                int port;
                cout << "Neue Adresse eingeben: " ; cin >> adresse; cout << '\n';
                cout << "Neuen Port eingeben  : " ; cin >> port; cout << '\n';
                c_address addr2( adresse, port); 
                msocket.setgroup(addr2);
                break;
            }
	
            case 'b':
            {
                msocket.joingroup();
                break;
            }

            case 'c':
            {
                msocket.leavegroup();
                break;
            }

            case 'd':
            {
                int wahl;
                u_char ttl;
                cout << "Neue ttl eingeben: " ; cin >> wahl; cout << '\n';
                ttl = (u_char)wahl;
                int wert = msocket.set_ttl(ttl);
                if (wert != 0)
                {
                    cout << "ERROR" << wert << "\n";
                    cout << "errno: " << errno << '\n';
                }
                break;
            }

            case 'e':
            {
                msocket.read(buf,sizeof(buf));
                cout << buf << '\n';
                break;
            }

            case 'f':
            {
                cout << "Text : " ; cin >> buf ; cout << '\n';
                msocket.write(buf,sizeof(buf));
                break;
            }

            case 'g':
            {
                int res;
                res = msocket.poll(buf,sizeof(buf),10);
                cout << "res ist: " << res << '\n';
                if (res != -2)
                {
                    cout << buf << '\n';
                }
                else
                {
                    cout << "nix gekommen\n";
                }
                break;
		
            }
            case 'h':
            {
                msocket.getpeer(addback);
                cout << "Server-Addr    : " << addback.getinetaddr() << endl
                     << "Sender-Port    : " << addback.getport() << endl
                     << "Sender-Addresse: " << addback << endl << flush;
                break;

            }
            case 'i':
            {
                msocket.getgroupaddr(addback);
                cout << "Gruppen-Addr    : " << addback.getinetaddr() << endl
                     << "Gruppen-Port    : " << addback.getport() << endl
                     << "Gruppen-Addresse: " << addback << endl << flush;
                break;
            }
            case 'j':
            {
                u_char one = 1;
                cout << "LoopBack: " << msocket.loopback(one) << endl << flush;
                break;
            }

            case 'k':
            {
                u_char zero = 0;
                cout << "LoopBack: " << msocket.loopback(zero) << endl << flush;
                break;
            }
            case 'l':
            {
		cout << "interface: ";
		cin >> hostbuf;
                msocket.joingroup(hostbuf);
                break;
            }

        } // END OF switch()

    } // END OF for(;;)

} // END OF main()
