
#include <stdio.h>
#include <fpsema.h>
#include <string.h>

/*
 * Kleines Semaphorentestprogramm
 *
 * Befehle:
 *  new <int> <int> <int>
 *      Allokiere Semaphoren. 1. Parameter = Key, 2. Parameter = nsims
 *      3. = excl
 *
 *  inc <int>
 *      Inkrementiere Semaphore
 *
 *  dec <int> [noblock]
 *      Dekrementiere Semaphore
 *
 *  kill <int>
 *      Loesche Set.
 */

int
main (int argc, char *argv[])
{
  char s[256];
  fpSema *sema;
  int p1, p2, p3;

  while (!feof (stdin)) {
    p1 = p2 = p3 = 0;
    sscanf (gets(s), "%*s %d %d %d", &p1, &p2, &p3);

    switch (s[0]) {
    case 'n':
      sema = new fpSema ((key_t) p1, p2, S_IRWXU, p3);
      if (sema->error()) {
	printf ("error: %s\n", strerror (sema->error()));
	delete sema;
      }
      break;

    case 'i':
      (*sema)[p1]++;
      break;

    case 'd':
      (*sema)[p1].decr(p2);
      if (sema->error()) {
	printf ("error: %s\n", strerror (sema->error()));
      }
      break;

    case 'k':
      delete sema;
      break;

    case 'q':
      printf ("%d\n", (int) ((*sema)[p1]));
      break;
    }
  }
}
