/*****************************************************************
**************  sync_bsp_new.cxx  *************************************
*****************************************************************/
#include <thread_class.h>
#include <itc.h>
#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>

// Klasse fuer gemeinsame Daten; abgeleitet von "c_section"
// c_section: "kritischer Abschnitt"

class c_shareddata: public c_section {
	public:

	c_shareddata();
	~c_shareddata();
	int number;		// zu uebergebendes Datum (Datenpuffer)
	int occupied;		// Belegt-Flag
};	

// Klasse der produzierenden Thread:
class c_prod_thread : public c_thread {
	public:
		void* thread_main(void*);
};

// Klasse der konsumierenden Thread:
class c_cons_thread : public c_thread {
	public:
		void* thread_main(void*);
};

c_shareddata::c_shareddata(){
	occupied = 0;	// Datenpuffer ist initial leer
}

c_shareddata::~c_shareddata(){
}

void* c_prod_thread::thread_main(void* arg){
	// Auslesen des Funktionsarguments:
	c_shareddata* p_daten = (c_shareddata*)arg;
	int i;

	for(i=0;i<25;i++){
		
		p_daten->enter(); // Betreten des krit. Abschnitts

		// Warten auf leeren Datenpuffer:
		while (p_daten->occupied == 1){
			p_daten->wait();
		};
		// Produktion eines Datums:
		p_daten->number = i*i;
		p_daten->occupied = 1;	 // Puffer ist belegt
		// Signalisieren einer Aenderung im krit. Abschnitt
		p_daten->signal();
		p_daten->leave(); // Verlassen des krit. Abschnitts

	};
	return NULL;
}

void* c_cons_thread::thread_main(void* arg){
	c_shareddata* p_daten = (c_shareddata*)arg;
	int i,data_value;

	for(i=0;i<25;i++){

		p_daten->enter();
		// Warten auf gueltiges Datum:
		while (p_daten->occupied == 0){
			p_daten->wait();
		};
		// Auslesen und verarbeiten des Datums:
		data_value = p_daten->number;
		data_value = data_value+1000;
		cout << "Berechneter wert : "<<data_value<<endl;
		p_daten->occupied = 0;	// Puffer ist leer
		p_daten->signal();
		p_daten->leave();

	};
	return NULL;
}

main(){

	c_prod_thread producer;
	c_cons_thread consumer;

	c_shareddata datenobj;	


	producer.start(&datenobj);
	consumer.start(&datenobj);

	producer.join();
	consumer.join();

	cout<<"bye bye !!!!!!!\n";

	return 1;

}


